/* utils.c generated by valac 0.56.17, the Vala compiler
 * generated from utils.vala, do not modify */

/* SPDX-FileCopyrightText: 2010-2020 Sébastien Wilmet
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <tepl/tepl.h>
#include <gtk/gtk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))

VALA_EXTERN gboolean utils_char_is_escaped (const gchar* text,
                                glong char_index);
VALA_EXTERN const gchar* utils_get_string_from_resource (const gchar* resource_path);
VALA_EXTERN void utils_delete_file (GFile* file);
VALA_EXTERN gboolean utils_save_file (GFile* file,
                          const gchar* contents,
                          gboolean make_backup);
VALA_EXTERN gchar* utils_load_file (GFile* file);
VALA_EXTERN gchar* utils_get_relative_path (GFile* origin,
                                GFile* target,
                                GFile* common_dir);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN GtkScrolledWindow* utils_add_scrollbar (GtkWidget* child);
VALA_EXTERN gint utils_get_selected_row (GtkTreeView* view,
                             GtkTreeIter* iter);
static void _vala_GtkTreePath_free (GtkTreePath* self);
VALA_EXTERN GtkWindow* utils_get_toplevel_window (GtkWidget* widget);
VALA_EXTERN void utils_flush_queue (void);

/*************************************************************************/
static gboolean
string_get_prev_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1341 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1342 "glib-2.0.vapi"
	if (0 < (*index)) {
#line 72 "utils.c"
		gchar* _tmp0_;
#line 1343 "glib-2.0.vapi"
		_tmp0_ = g_utf8_prev_char (((gchar*) self) + (*index));
#line 1343 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1344 "glib-2.0.vapi"
		_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1345 "glib-2.0.vapi"
		result = TRUE;
#line 1345 "glib-2.0.vapi"
		if (c) {
#line 1345 "glib-2.0.vapi"
			*c = _vala_c;
#line 86 "utils.c"
		}
#line 1345 "glib-2.0.vapi"
		return result;
#line 90 "utils.c"
	} else {
#line 1347 "glib-2.0.vapi"
		_vala_c = (gunichar) 0;
#line 1348 "glib-2.0.vapi"
		result = FALSE;
#line 1348 "glib-2.0.vapi"
		if (c) {
#line 1348 "glib-2.0.vapi"
			*c = _vala_c;
#line 100 "utils.c"
		}
#line 1348 "glib-2.0.vapi"
		return result;
#line 104 "utils.c"
	}
}

gboolean
utils_char_is_escaped (const gchar* text,
                       glong char_index)
{
	gint _tmp0_;
	gint _tmp1_;
	gboolean escaped = FALSE;
	gint index = 0;
	gunichar cur_char = 0U;
	gboolean result;
#line 12 "../src/utils.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 14 "../src/utils.vala"
	_tmp0_ = strlen (text);
#line 14 "../src/utils.vala"
	_tmp1_ = _tmp0_;
#line 14 "../src/utils.vala"
	g_return_val_if_fail (char_index < ((glong) _tmp1_), FALSE);
#line 16 "../src/utils.vala"
	escaped = FALSE;
#line 17 "../src/utils.vala"
	index = (gint) char_index;
#line 19 "../src/utils.vala"
	while (TRUE) {
#line 132 "utils.c"
		gunichar _tmp2_ = 0U;
		gboolean _tmp3_;
#line 19 "../src/utils.vala"
		_tmp3_ = string_get_prev_char (text, &index, &_tmp2_);
#line 19 "../src/utils.vala"
		cur_char = _tmp2_;
#line 19 "../src/utils.vala"
		if (!_tmp3_) {
#line 19 "../src/utils.vala"
			break;
#line 143 "utils.c"
		}
#line 21 "../src/utils.vala"
		if (cur_char != ((gunichar) '\\')) {
#line 22 "../src/utils.vala"
			break;
#line 149 "utils.c"
		}
#line 24 "../src/utils.vala"
		escaped = !escaped;
#line 153 "utils.c"
	}
#line 27 "../src/utils.vala"
	result = escaped;
#line 27 "../src/utils.vala"
	return result;
#line 159 "utils.c"
}

const gchar*
utils_get_string_from_resource (const gchar* resource_path)
{
	GError* _inner_error0_ = NULL;
	const gchar* result;
#line 30 "../src/utils.vala"
	g_return_val_if_fail (resource_path != NULL, NULL);
#line 169 "utils.c"
	{
		GBytes* bytes = NULL;
		GBytes* _tmp0_;
		gsize _tmp1_ = 0;
		guint8* _tmp2_;
#line 34 "../src/utils.vala"
		_tmp0_ = g_resources_lookup_data (resource_path, 0, &_inner_error0_);
#line 34 "../src/utils.vala"
		bytes = _tmp0_;
#line 34 "../src/utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 181 "utils.c"
			goto __catch0_g_error;
		}
#line 35 "../src/utils.vala"
		_tmp2_ = g_bytes_get_data (bytes, &_tmp1_);
#line 35 "../src/utils.vala"
		result = (const gchar*) _tmp2_;
#line 35 "../src/utils.vala"
		_g_bytes_unref0 (bytes);
#line 35 "../src/utils.vala"
		return result;
#line 192 "utils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 32 "../src/utils.vala"
		e = _inner_error0_;
#line 32 "../src/utils.vala"
		_inner_error0_ = NULL;
#line 39 "../src/utils.vala"
		_tmp3_ = e;
#line 39 "../src/utils.vala"
		_tmp4_ = _tmp3_->message;
#line 39 "../src/utils.vala"
		g_warning ("utils.vala:39: Failed to load data from resource '%s': %s", resource_path, _tmp4_);
#line 41 "../src/utils.vala"
		result = NULL;
#line 41 "../src/utils.vala"
		_g_error_free0 (e);
#line 41 "../src/utils.vala"
		return result;
#line 216 "utils.c"
	}
	__finally0:
#line 32 "../src/utils.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 32 "../src/utils.vala"
	g_clear_error (&_inner_error0_);
#line 32 "../src/utils.vala"
	return NULL;
#line 225 "utils.c"
}

/*************************************************************************/
void
utils_delete_file (GFile* file)
{
	GError* _inner_error0_ = NULL;
#line 51 "../src/utils.vala"
	g_return_if_fail (file != NULL);
#line 53 "../src/utils.vala"
	if (!g_file_query_exists (file, NULL)) {
#line 54 "../src/utils.vala"
		return;
#line 239 "utils.c"
	}
	{
#line 58 "../src/utils.vala"
		g_file_delete (file, NULL, &_inner_error0_);
#line 58 "../src/utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 246 "utils.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 56 "../src/utils.vala"
		e = _inner_error0_;
#line 56 "../src/utils.vala"
		_inner_error0_ = NULL;
#line 62 "../src/utils.vala"
		_tmp0_ = g_file_get_parse_name (file);
#line 62 "../src/utils.vala"
		_tmp1_ = _tmp0_;
#line 62 "../src/utils.vala"
		_tmp2_ = e;
#line 62 "../src/utils.vala"
		_tmp3_ = _tmp2_->message;
#line 62 "../src/utils.vala"
		g_warning ("utils.vala:62: Delete file '%s' failed: %s", _tmp1_, _tmp3_);
#line 62 "../src/utils.vala"
		_g_free0 (_tmp1_);
#line 56 "../src/utils.vala"
		_g_error_free0 (e);
#line 276 "utils.c"
	}
	__finally0:
#line 56 "../src/utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 56 "../src/utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 56 "../src/utils.vala"
		g_clear_error (&_inner_error0_);
#line 56 "../src/utils.vala"
		return;
#line 287 "utils.c"
	}
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 325 "utils.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 331 "utils.c"
}

gboolean
utils_save_file (GFile* file,
                 const gchar* contents,
                 gboolean make_backup)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 66 "../src/utils.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 66 "../src/utils.vala"
	g_return_val_if_fail (contents != NULL, FALSE);
#line 345 "utils.c"
	{
		guint8* _tmp0_;
		gint _tmp0__length1;
		gint _tmp1_ = 0;
		guint8* _tmp2_;
		gint _tmp2__length1;
#line 70 "../src/utils.vala"
		tepl_utils_create_parent_directories (file, NULL, &_inner_error0_);
#line 70 "../src/utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 356 "utils.c"
			goto __catch0_g_error;
		}
#line 72 "../src/utils.vala"
		_tmp0_ = string_get_data (contents, &_tmp1_);
#line 72 "../src/utils.vala"
		_tmp0__length1 = _tmp1_;
#line 72 "../src/utils.vala"
		_tmp2_ = _tmp0_;
#line 72 "../src/utils.vala"
		_tmp2__length1 = _tmp0__length1;
#line 72 "../src/utils.vala"
		g_file_replace_contents (file, (const char*) _tmp2_, (gsize) _tmp2__length1, NULL, make_backup, G_FILE_CREATE_NONE, NULL, NULL, &_inner_error0_);
#line 72 "../src/utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 371 "utils.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 68 "../src/utils.vala"
		e = _inner_error0_;
#line 68 "../src/utils.vala"
		_inner_error0_ = NULL;
#line 77 "../src/utils.vala"
		_tmp3_ = g_file_get_parse_name (file);
#line 77 "../src/utils.vala"
		_tmp4_ = _tmp3_;
#line 77 "../src/utils.vala"
		_tmp5_ = e;
#line 77 "../src/utils.vala"
		_tmp6_ = _tmp5_->message;
#line 77 "../src/utils.vala"
		g_warning ("utils.vala:77: Failed to save the file '%s': %s", _tmp4_, _tmp6_);
#line 77 "../src/utils.vala"
		_g_free0 (_tmp4_);
#line 79 "../src/utils.vala"
		result = FALSE;
#line 79 "../src/utils.vala"
		_g_error_free0 (e);
#line 79 "../src/utils.vala"
		return result;
#line 405 "utils.c"
	}
	__finally0:
#line 68 "../src/utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 410 "utils.c"
		gboolean _tmp7_ = FALSE;
#line 68 "../src/utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 68 "../src/utils.vala"
		g_clear_error (&_inner_error0_);
#line 68 "../src/utils.vala"
		return _tmp7_;
#line 418 "utils.c"
	}
#line 82 "../src/utils.vala"
	result = TRUE;
#line 82 "../src/utils.vala"
	return result;
#line 424 "utils.c"
}

gchar*
utils_load_file (GFile* file)
{
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 86 "../src/utils.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 434 "utils.c"
	{
		guint8* chars = NULL;
		gint chars_length1 = 0;
		gint _chars_size_ = 0;
		guint8* _tmp0_ = NULL;
		gsize _tmp1_ = 0;
		guint8* _tmp2_;
		gint _tmp2__length1;
#line 91 "../src/utils.vala"
		g_file_load_contents (file, NULL, &_tmp0_, &_tmp1_, NULL, &_inner_error0_);
#line 91 "../src/utils.vala"
		chars = (g_free (chars), NULL);
#line 91 "../src/utils.vala"
		chars = _tmp0_;
#line 91 "../src/utils.vala"
		chars_length1 = _tmp1_;
#line 91 "../src/utils.vala"
		_chars_size_ = chars_length1;
#line 91 "../src/utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 91 "../src/utils.vala"
			chars = (g_free (chars), NULL);
#line 457 "utils.c"
			goto __catch0_g_error;
		}
#line 92 "../src/utils.vala"
		_tmp2_ = chars;
#line 92 "../src/utils.vala"
		_tmp2__length1 = chars_length1;
#line 92 "../src/utils.vala"
		chars = NULL;
#line 92 "../src/utils.vala"
		chars_length1 = 0;
#line 92 "../src/utils.vala"
		result = (gchar*) _tmp2_;
#line 92 "../src/utils.vala"
		chars = (g_free (chars), NULL);
#line 92 "../src/utils.vala"
		return result;
#line 474 "utils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 88 "../src/utils.vala"
		e = _inner_error0_;
#line 88 "../src/utils.vala"
		_inner_error0_ = NULL;
#line 96 "../src/utils.vala"
		_tmp3_ = g_file_get_parse_name (file);
#line 96 "../src/utils.vala"
		_tmp4_ = _tmp3_;
#line 96 "../src/utils.vala"
		_tmp5_ = e;
#line 96 "../src/utils.vala"
		_tmp6_ = _tmp5_->message;
#line 96 "../src/utils.vala"
		g_warning ("utils.vala:96: Failed to load the file '%s': %s", _tmp4_, _tmp6_);
#line 96 "../src/utils.vala"
		_g_free0 (_tmp4_);
#line 98 "../src/utils.vala"
		result = NULL;
#line 98 "../src/utils.vala"
		_g_error_free0 (e);
#line 98 "../src/utils.vala"
		return result;
#line 506 "utils.c"
	}
	__finally0:
#line 88 "../src/utils.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 88 "../src/utils.vala"
	g_clear_error (&_inner_error0_);
#line 88 "../src/utils.vala"
	return NULL;
#line 515 "utils.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 110 "../src/utils.vala"
	return self ? g_object_ref (self) : NULL;
#line 523 "utils.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 170 "../src/utils.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 531 "utils.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 170 "../src/utils.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 539 "utils.c"
}

gchar*
utils_get_relative_path (GFile* origin,
                         GFile* target,
                         GFile* common_dir)
{
	GFile* origin_dir = NULL;
	GFile* target_parent = NULL;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GList* target_dirs = NULL;
	GList* origin_dirs = NULL;
	guint dir_index = 0U;
	guint nb_common_dirs = 0U;
	gchar* relative_path = NULL;
	gchar* _tmp34_;
	guint nb_remaining_origin_dirs = 0U;
	GList* _tmp35_;
	const gchar* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	gchar* result;
#line 106 "../src/utils.vala"
	g_return_val_if_fail (origin != NULL, NULL);
#line 106 "../src/utils.vala"
	g_return_val_if_fail (target != NULL, NULL);
#line 106 "../src/utils.vala"
	g_return_val_if_fail (common_dir != NULL, NULL);
#line 109 "../src/utils.vala"
	if (g_file_equal (origin, common_dir)) {
#line 575 "utils.c"
		GFile* _tmp0_;
#line 110 "../src/utils.vala"
		_tmp0_ = _g_object_ref0 (origin);
#line 110 "../src/utils.vala"
		_g_object_unref0 (origin_dir);
#line 110 "../src/utils.vala"
		origin_dir = _tmp0_;
#line 583 "utils.c"
	} else {
		GFile* _tmp1_;
#line 112 "../src/utils.vala"
		_tmp1_ = g_file_get_parent (origin);
#line 112 "../src/utils.vala"
		_g_object_unref0 (origin_dir);
#line 112 "../src/utils.vala"
		origin_dir = _tmp1_;
#line 592 "utils.c"
	}
#line 114 "../src/utils.vala"
	_tmp2_ = g_file_get_parent (target);
#line 114 "../src/utils.vala"
	target_parent = _tmp2_;
#line 116 "../src/utils.vala"
	_tmp3_ = origin_dir;
#line 116 "../src/utils.vala"
	g_return_val_if_fail (_tmp3_ != NULL, NULL);
#line 117 "../src/utils.vala"
	_tmp4_ = target_parent;
#line 117 "../src/utils.vala"
	g_return_val_if_fail (_tmp4_ != NULL, NULL);
#line 120 "../src/utils.vala"
	_tmp5_ = target_parent;
#line 120 "../src/utils.vala"
	_tmp6_ = origin_dir;
#line 120 "../src/utils.vala"
	if (g_file_equal (_tmp5_, _tmp6_)) {
#line 612 "utils.c"
		gchar* _tmp7_;
#line 121 "../src/utils.vala"
		_tmp7_ = g_file_get_basename (target);
#line 121 "../src/utils.vala"
		result = _tmp7_;
#line 121 "../src/utils.vala"
		_g_object_unref0 (target_parent);
#line 121 "../src/utils.vala"
		_g_object_unref0 (origin_dir);
#line 121 "../src/utils.vala"
		return result;
#line 624 "utils.c"
	}
#line 124 "../src/utils.vala"
	target_dirs = NULL;
#line 125 "../src/utils.vala"
	origin_dirs = NULL;
#line 127 "../src/utils.vala"
	while (TRUE) {
#line 632 "utils.c"
		gboolean _tmp8_ = FALSE;
		GFile* _tmp9_;
		GFile* _tmp11_;
		GFile* _tmp12_;
		GFile* _tmp13_;
		GFile* _tmp14_;
#line 127 "../src/utils.vala"
		_tmp9_ = target_parent;
#line 127 "../src/utils.vala"
		if (_tmp9_ != NULL) {
#line 643 "utils.c"
			GFile* _tmp10_;
#line 127 "../src/utils.vala"
			_tmp10_ = target_parent;
#line 127 "../src/utils.vala"
			_tmp8_ = !g_file_equal (_tmp10_, common_dir);
#line 649 "utils.c"
		} else {
#line 127 "../src/utils.vala"
			_tmp8_ = FALSE;
#line 653 "utils.c"
		}
#line 127 "../src/utils.vala"
		if (!_tmp8_) {
#line 127 "../src/utils.vala"
			break;
#line 659 "utils.c"
		}
#line 129 "../src/utils.vala"
		_tmp11_ = target_parent;
#line 129 "../src/utils.vala"
		_tmp12_ = _g_object_ref0 (_tmp11_);
#line 129 "../src/utils.vala"
		target_dirs = g_list_prepend (target_dirs, _tmp12_);
#line 130 "../src/utils.vala"
		_tmp13_ = target_parent;
#line 130 "../src/utils.vala"
		_tmp14_ = g_file_get_parent (_tmp13_);
#line 130 "../src/utils.vala"
		_g_object_unref0 (target_parent);
#line 130 "../src/utils.vala"
		target_parent = _tmp14_;
#line 675 "utils.c"
	}
#line 133 "../src/utils.vala"
	while (TRUE) {
#line 679 "utils.c"
		gboolean _tmp15_ = FALSE;
		GFile* _tmp16_;
		GFile* _tmp18_;
		GFile* _tmp19_;
		GFile* _tmp20_;
		GFile* _tmp21_;
#line 133 "../src/utils.vala"
		_tmp16_ = origin_dir;
#line 133 "../src/utils.vala"
		if (_tmp16_ != NULL) {
#line 690 "utils.c"
			GFile* _tmp17_;
#line 133 "../src/utils.vala"
			_tmp17_ = origin_dir;
#line 133 "../src/utils.vala"
			_tmp15_ = !g_file_equal (_tmp17_, common_dir);
#line 696 "utils.c"
		} else {
#line 133 "../src/utils.vala"
			_tmp15_ = FALSE;
#line 700 "utils.c"
		}
#line 133 "../src/utils.vala"
		if (!_tmp15_) {
#line 133 "../src/utils.vala"
			break;
#line 706 "utils.c"
		}
#line 135 "../src/utils.vala"
		_tmp18_ = origin_dir;
#line 135 "../src/utils.vala"
		_tmp19_ = _g_object_ref0 (_tmp18_);
#line 135 "../src/utils.vala"
		origin_dirs = g_list_prepend (origin_dirs, _tmp19_);
#line 136 "../src/utils.vala"
		_tmp20_ = origin_dir;
#line 136 "../src/utils.vala"
		_tmp21_ = g_file_get_parent (_tmp20_);
#line 136 "../src/utils.vala"
		_g_object_unref0 (origin_dir);
#line 136 "../src/utils.vala"
		origin_dir = _tmp21_;
#line 722 "utils.c"
	}
#line 140 "../src/utils.vala"
	dir_index = (guint) 0;
#line 141 "../src/utils.vala"
	while (TRUE) {
#line 728 "utils.c"
		gboolean _tmp22_ = FALSE;
		GList* _tmp23_;
		GFile* cur_target_dir = NULL;
		GList* _tmp25_;
		gconstpointer _tmp26_;
		GFile* _tmp27_;
		GFile* cur_origin_dir = NULL;
		GList* _tmp28_;
		gconstpointer _tmp29_;
		GFile* _tmp30_;
		GFile* _tmp31_;
		GFile* _tmp32_;
		guint _tmp33_;
#line 141 "../src/utils.vala"
		_tmp23_ = target_dirs;
#line 141 "../src/utils.vala"
		if (dir_index < g_list_length (_tmp23_)) {
#line 746 "utils.c"
			GList* _tmp24_;
#line 141 "../src/utils.vala"
			_tmp24_ = origin_dirs;
#line 141 "../src/utils.vala"
			_tmp22_ = dir_index < g_list_length (_tmp24_);
#line 752 "utils.c"
		} else {
#line 141 "../src/utils.vala"
			_tmp22_ = FALSE;
#line 756 "utils.c"
		}
#line 141 "../src/utils.vala"
		if (!_tmp22_) {
#line 141 "../src/utils.vala"
			break;
#line 762 "utils.c"
		}
#line 143 "../src/utils.vala"
		_tmp25_ = target_dirs;
#line 143 "../src/utils.vala"
		_tmp26_ = g_list_nth_data (_tmp25_, dir_index);
#line 143 "../src/utils.vala"
		_tmp27_ = _g_object_ref0 ((GFile*) _tmp26_);
#line 143 "../src/utils.vala"
		cur_target_dir = _tmp27_;
#line 144 "../src/utils.vala"
		_tmp28_ = origin_dirs;
#line 144 "../src/utils.vala"
		_tmp29_ = g_list_nth_data (_tmp28_, dir_index);
#line 144 "../src/utils.vala"
		_tmp30_ = _g_object_ref0 ((GFile*) _tmp29_);
#line 144 "../src/utils.vala"
		cur_origin_dir = _tmp30_;
#line 145 "../src/utils.vala"
		_tmp31_ = cur_target_dir;
#line 145 "../src/utils.vala"
		_tmp32_ = cur_origin_dir;
#line 145 "../src/utils.vala"
		if (!g_file_equal (_tmp31_, _tmp32_)) {
#line 146 "../src/utils.vala"
			_g_object_unref0 (cur_origin_dir);
#line 146 "../src/utils.vala"
			_g_object_unref0 (cur_target_dir);
#line 146 "../src/utils.vala"
			break;
#line 792 "utils.c"
		}
#line 148 "../src/utils.vala"
		_tmp33_ = dir_index;
#line 148 "../src/utils.vala"
		dir_index = _tmp33_ + 1;
#line 141 "../src/utils.vala"
		_g_object_unref0 (cur_origin_dir);
#line 141 "../src/utils.vala"
		_g_object_unref0 (cur_target_dir);
#line 802 "utils.c"
	}
#line 151 "../src/utils.vala"
	nb_common_dirs = dir_index;
#line 154 "../src/utils.vala"
	_tmp34_ = g_strdup ("");
#line 154 "../src/utils.vala"
	relative_path = _tmp34_;
#line 157 "../src/utils.vala"
	_tmp35_ = origin_dirs;
#line 157 "../src/utils.vala"
	nb_remaining_origin_dirs = g_list_length (_tmp35_) - nb_common_dirs;
#line 814 "utils.c"
	{
		guint i = 0U;
#line 158 "../src/utils.vala"
		i = (guint) 0;
#line 819 "utils.c"
		{
			gboolean _tmp36_ = FALSE;
#line 158 "../src/utils.vala"
			_tmp36_ = TRUE;
#line 158 "../src/utils.vala"
			while (TRUE) {
#line 826 "utils.c"
				const gchar* _tmp38_;
				gchar* _tmp39_;
#line 158 "../src/utils.vala"
				if (!_tmp36_) {
#line 831 "utils.c"
					guint _tmp37_;
#line 158 "../src/utils.vala"
					_tmp37_ = i;
#line 158 "../src/utils.vala"
					i = _tmp37_ + 1;
#line 837 "utils.c"
				}
#line 158 "../src/utils.vala"
				_tmp36_ = FALSE;
#line 158 "../src/utils.vala"
				if (!(i < nb_remaining_origin_dirs)) {
#line 158 "../src/utils.vala"
					break;
#line 845 "utils.c"
				}
#line 159 "../src/utils.vala"
				_tmp38_ = relative_path;
#line 159 "../src/utils.vala"
				_tmp39_ = g_strconcat (_tmp38_, "../", NULL);
#line 159 "../src/utils.vala"
				_g_free0 (relative_path);
#line 159 "../src/utils.vala"
				relative_path = _tmp39_;
#line 855 "utils.c"
			}
		}
	}
	{
		guint i = 0U;
#line 162 "../src/utils.vala"
		i = nb_common_dirs;
#line 863 "utils.c"
		{
			gboolean _tmp40_ = FALSE;
#line 162 "../src/utils.vala"
			_tmp40_ = TRUE;
#line 162 "../src/utils.vala"
			while (TRUE) {
#line 870 "utils.c"
				GList* _tmp42_;
				GFile* cur_target_dir = NULL;
				GList* _tmp43_;
				gconstpointer _tmp44_;
				GFile* _tmp45_;
				const gchar* _tmp46_;
				GFile* _tmp47_;
				gchar* _tmp48_;
				gchar* _tmp49_;
				gchar* _tmp50_;
				gchar* _tmp51_;
				gchar* _tmp52_;
#line 162 "../src/utils.vala"
				if (!_tmp40_) {
#line 885 "utils.c"
					guint _tmp41_;
#line 162 "../src/utils.vala"
					_tmp41_ = i;
#line 162 "../src/utils.vala"
					i = _tmp41_ + 1;
#line 891 "utils.c"
				}
#line 162 "../src/utils.vala"
				_tmp40_ = FALSE;
#line 162 "../src/utils.vala"
				_tmp42_ = target_dirs;
#line 162 "../src/utils.vala"
				if (!(i < g_list_length (_tmp42_))) {
#line 162 "../src/utils.vala"
					break;
#line 901 "utils.c"
				}
#line 164 "../src/utils.vala"
				_tmp43_ = target_dirs;
#line 164 "../src/utils.vala"
				_tmp44_ = g_list_nth_data (_tmp43_, i);
#line 164 "../src/utils.vala"
				_tmp45_ = _g_object_ref0 ((GFile*) _tmp44_);
#line 164 "../src/utils.vala"
				cur_target_dir = _tmp45_;
#line 165 "../src/utils.vala"
				_tmp46_ = relative_path;
#line 165 "../src/utils.vala"
				_tmp47_ = cur_target_dir;
#line 165 "../src/utils.vala"
				_tmp48_ = g_file_get_basename (_tmp47_);
#line 165 "../src/utils.vala"
				_tmp49_ = _tmp48_;
#line 165 "../src/utils.vala"
				_tmp50_ = g_strconcat (_tmp49_, "/", NULL);
#line 165 "../src/utils.vala"
				_tmp51_ = _tmp50_;
#line 165 "../src/utils.vala"
				_tmp52_ = g_strconcat (_tmp46_, _tmp51_, NULL);
#line 165 "../src/utils.vala"
				_g_free0 (relative_path);
#line 165 "../src/utils.vala"
				relative_path = _tmp52_;
#line 165 "../src/utils.vala"
				_g_free0 (_tmp51_);
#line 165 "../src/utils.vala"
				_g_free0 (_tmp49_);
#line 162 "../src/utils.vala"
				_g_object_unref0 (cur_target_dir);
#line 935 "utils.c"
			}
		}
	}
#line 169 "../src/utils.vala"
	_tmp53_ = relative_path;
#line 169 "../src/utils.vala"
	_tmp54_ = g_file_get_basename (target);
#line 169 "../src/utils.vala"
	_tmp55_ = _tmp54_;
#line 169 "../src/utils.vala"
	_tmp56_ = g_strconcat (_tmp53_, _tmp55_, NULL);
#line 169 "../src/utils.vala"
	_g_free0 (relative_path);
#line 169 "../src/utils.vala"
	relative_path = _tmp56_;
#line 169 "../src/utils.vala"
	_g_free0 (_tmp55_);
#line 170 "../src/utils.vala"
	result = relative_path;
#line 170 "../src/utils.vala"
	(origin_dirs == NULL) ? NULL : (origin_dirs = (_g_list_free__g_object_unref0_ (origin_dirs), NULL));
#line 170 "../src/utils.vala"
	(target_dirs == NULL) ? NULL : (target_dirs = (_g_list_free__g_object_unref0_ (target_dirs), NULL));
#line 170 "../src/utils.vala"
	_g_object_unref0 (target_parent);
#line 170 "../src/utils.vala"
	_g_object_unref0 (origin_dir);
#line 170 "../src/utils.vala"
	return result;
#line 965 "utils.c"
}

/*************************************************************************/
GtkScrolledWindow*
utils_add_scrollbar (GtkWidget* child)
{
	GtkScrolledWindow* sw = NULL;
	GtkScrolledWindow* _tmp0_;
	GtkScrolledWindow* result;
#line 177 "../src/utils.vala"
	g_return_val_if_fail (child != NULL, NULL);
#line 179 "../src/utils.vala"
	_tmp0_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 179 "../src/utils.vala"
	g_object_ref_sink (_tmp0_);
#line 179 "../src/utils.vala"
	sw = _tmp0_;
#line 180 "../src/utils.vala"
	gtk_container_add ((GtkContainer*) sw, child);
#line 181 "../src/utils.vala"
	result = sw;
#line 181 "../src/utils.vala"
	return result;
#line 989 "utils.c"
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 193 "../src/utils.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 997 "utils.c"
}

gint
utils_get_selected_row (GtkTreeView* view,
                        GtkTreeIter* iter)
{
	GtkTreeIter _vala_iter = {0};
	GtkTreeSelection* select = NULL;
	GtkTreeSelection* _tmp0_;
	GtkTreeSelection* _tmp1_;
	GtkTreeSelection* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	gboolean _tmp4_;
	gint result;
#line 186 "../src/utils.vala"
	g_return_val_if_fail (view != NULL, 0);
#line 188 "../src/utils.vala"
	_tmp0_ = gtk_tree_view_get_selection (view);
#line 188 "../src/utils.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 188 "../src/utils.vala"
	select = _tmp1_;
#line 189 "../src/utils.vala"
	_tmp2_ = select;
#line 189 "../src/utils.vala"
	_tmp4_ = gtk_tree_selection_get_selected (_tmp2_, NULL, &_tmp3_);
#line 189 "../src/utils.vala"
	_vala_iter = _tmp3_;
#line 189 "../src/utils.vala"
	if (_tmp4_) {
#line 1028 "utils.c"
		GtkTreeModel* model = NULL;
		GtkTreeModel* _tmp5_;
		GtkTreeModel* _tmp6_;
		GtkTreePath* path = NULL;
		GtkTreeModel* _tmp7_;
		GtkTreeIter _tmp8_;
		GtkTreePath* _tmp9_;
		GtkTreePath* _tmp10_;
		gint _tmp11_ = 0;
		gint* _tmp12_;
		gint _tmp13_;
#line 191 "../src/utils.vala"
		_tmp5_ = gtk_tree_view_get_model (view);
#line 191 "../src/utils.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 191 "../src/utils.vala"
		model = _tmp6_;
#line 192 "../src/utils.vala"
		_tmp7_ = model;
#line 192 "../src/utils.vala"
		_tmp8_ = _vala_iter;
#line 192 "../src/utils.vala"
		_tmp9_ = gtk_tree_model_get_path (_tmp7_, &_tmp8_);
#line 192 "../src/utils.vala"
		path = _tmp9_;
#line 193 "../src/utils.vala"
		_tmp10_ = path;
#line 193 "../src/utils.vala"
		_tmp12_ = gtk_tree_path_get_indices_with_depth (_tmp10_, &_tmp11_);
#line 193 "../src/utils.vala"
		_tmp13_ = _tmp12_[0];
#line 193 "../src/utils.vala"
		result = _tmp13_;
#line 193 "../src/utils.vala"
		__vala_GtkTreePath_free0 (path);
#line 193 "../src/utils.vala"
		_g_object_unref0 (model);
#line 193 "../src/utils.vala"
		_g_object_unref0 (select);
#line 193 "../src/utils.vala"
		if (iter) {
#line 193 "../src/utils.vala"
			*iter = _vala_iter;
#line 1072 "utils.c"
		}
#line 193 "../src/utils.vala"
		return result;
#line 1076 "utils.c"
	}
#line 195 "../src/utils.vala"
	result = -1;
#line 195 "../src/utils.vala"
	_g_object_unref0 (select);
#line 195 "../src/utils.vala"
	if (iter) {
#line 195 "../src/utils.vala"
		*iter = _vala_iter;
#line 1086 "utils.c"
	}
#line 195 "../src/utils.vala"
	return result;
#line 1090 "utils.c"
}

GtkWindow*
utils_get_toplevel_window (GtkWidget* widget)
{
	GtkWidget* toplevel = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWindow* result;
#line 198 "../src/utils.vala"
	g_return_val_if_fail (widget != NULL, NULL);
#line 200 "../src/utils.vala"
	_tmp0_ = gtk_widget_get_toplevel (widget);
#line 200 "../src/utils.vala"
	toplevel = _tmp0_;
#line 202 "../src/utils.vala"
	_tmp1_ = toplevel;
#line 202 "../src/utils.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_window_get_type ())) {
#line 1110 "utils.c"
		GtkWidget* _tmp2_;
#line 203 "../src/utils.vala"
		_tmp2_ = toplevel;
#line 203 "../src/utils.vala"
		result = G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp2_) : NULL;
#line 203 "../src/utils.vala"
		return result;
#line 1118 "utils.c"
	}
#line 205 "../src/utils.vala"
	result = NULL;
#line 205 "../src/utils.vala"
	return result;
#line 1124 "utils.c"
}

/*************************************************************************/
void
utils_flush_queue (void)
{
#line 217 "../src/utils.vala"
	while (TRUE) {
#line 217 "../src/utils.vala"
		if (!gtk_events_pending ()) {
#line 217 "../src/utils.vala"
			break;
#line 1137 "utils.c"
		}
#line 218 "../src/utils.vala"
		gtk_main_iteration ();
#line 1141 "utils.c"
	}
}

